/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef DIAGRAM_H
#define DIAGRAM_H 1

class Visual;
class Node
{
	public:
		double dx, dy;
		Visual *obj;
};

class Edge
{
	public:
		Node *from;
		Node *to;
		double len;
};

class Main;
class Data;
class Diagram
{
	public:
		Diagram(Main *m);
		~Diagram();

		void dodraw(GdkPixmap *cnvs, GdkGC *gc, double zoom,
			int w, int h, int ox, int oy, int g);
		void network_links();
		void interface_color(GdkGC *gc, int type);

		void autoplace();
		void autoplace_init();
		Node *get_node(Visual*v);
		void compress(int sel);

		Main *main;
		Data *animate_objects;
		GdkPoint *points;
		gint full_width, full_height;	// size of diagram with zoom factor 1.0
		List edges;
		List nodes;
		int labels;
};

#endif

