/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef FILES_H
#define FILES_H 1

#include <time.h>
#include "data.h"

#define MAX_TIMESTAMP 16
#define MAX_VIEWS 64
#define GRID_SIZE 8

class Router;
class Machine;
class Main;
class Files
{
	public:
		Files(Main *m);
		~Files();

		int check();
		void topology();
		void status();
		void load_view(char *fname);
		void save_view(char *fname);
		void print_view(char *fname, int pw, int ph, int nw, int nh, int bw, int bh);
		void star();
		void stara(Router *r);
		void bunch();
		void buncha(Router *r);
		void width_height();
		void shift(int xx, int yy);
		void clear_tags();

		Main *main;
		FILE *f;
		Data *objects, *newobj;
		List filters;
		time_t timestamp[MAX_TIMESTAMP];
		int num_views;
		char current_view[64];
		int new_view;
		int update_in_progress;
};

#endif

