/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdio.h>
#include <pwd.h>
#include "main.h"
#include "misc.h"
#include "filesel.h"
//#include "images/icon.xpm"

static void file_ok_sel(GtkWidget *w, gpointer data)
{
	((FileSel*)data)->ok_sel();
}

static void file_cancel_sel(GtkWidget *w, gpointer data)
{
	((FileSel*)data)->hide();
}

static gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
	((FileSel*)data)->hide();
	return TRUE;
}

void FileSel::ok_sel()
{
	char buf[256];
	unsigned int i, j;

	if (status == 1)		// save as
	{
		main->files->save_view(gtk_file_selection_get_filename(GTK_FILE_SELECTION(window)));
	}else
	if (status == 2)		// load
	{
		main->files->load_view(gtk_file_selection_get_filename(GTK_FILE_SELECTION(window)));
	}else
	if (status == 3)		// print
	{
		strcpy(buf, gtk_file_selection_get_filename(GTK_FILE_SELECTION(window)));
		j = 0;
		for (i=0; i<strlen(buf); i++)
			if (buf[i] == '/') j=i;
		strcpy(main->print->filename, buf);
		gtk_entry_set_text(GTK_ENTRY(main->print->entry6), buf+j+1);
	}
	hide();
}

FileSel::FileSel(Main *m)
{
	main = m;
	create();
}

FileSel::~FileSel()
{
}

void FileSel::create()
{
//	GtkWidget *w;

	window = gtk_file_selection_new("File Selector");
//	w = GTK_WIDGET(window);
//	window_icon(w, icon_xpm);
//	gdk_window_set_icon_name(window, "Bounds");
	gtk_file_selection_hide_fileop_buttons(GTK_FILE_SELECTION(window));
//	gtk_signal_connect(GTK_OBJECT(window), "destroy",
//		GTK_SIGNAL_FUNC(gtk_main_quit), "WM destroy");
	gtk_signal_connect(GTK_OBJECT(window), "delete_event",
		GTK_SIGNAL_FUNC(delete_event), this);
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
		"clicked", (GtkSignalFunc)file_ok_sel, this);
	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(window)->cancel_button),
		"clicked", (GtkSignalFunc)file_cancel_sel, this);
}

void FileSel::saveas()
{
	struct passwd *p;
	char buf[256];

	p = getpwuid(getuid());
	sprintf(buf, "%s/%s/views/", p->pw_dir, HOME_DIR);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(window), buf);
  gtk_window_set_title(GTK_WINDOW(window), "Save View");

	status = 1;
	gtk_widget_show(window);
	gdk_window_raise(window->window);
}
/*
void FileSel::save()
{
	struct passwd *p;
	char buf[256];

	p = getpwuid(getuid());
	sprintf(buf, "%s/%s/views/", p->pw_dir, HOME_DIR);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(window), buf);
  gtk_window_set_title(GTK_WINDOW(window), "Save View");

	status = 1;
	gtk_widget_show(window);
	gdk_window_raise(window->window);
}
*/
void FileSel::load()
{
	struct passwd *p;
	char buf[256];

	p = getpwuid(getuid());
	sprintf(buf, "%s/%s/views/", p->pw_dir, HOME_DIR);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(window), buf);
  gtk_window_set_title(GTK_WINDOW(window), "Load View");

	status = 2;
	gtk_widget_show(window);
	gdk_window_raise(window->window);
}

void FileSel::print()
{
	struct passwd *p;
	char buf[256];

	p = getpwuid(getuid());
	sprintf(buf, "%s/%s/views/", p->pw_dir, HOME_DIR);
	gtk_file_selection_set_filename(GTK_FILE_SELECTION(window), buf);
  gtk_window_set_title(GTK_WINDOW(window), "Print");

	status = 3;
	gtk_widget_show(window);
	gdk_window_raise(window->window);
}

void FileSel::hide()
{
	gtk_widget_hide(window);
}

