/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef GRAPH_H
#define GRAPH_H 1

#include <gtk/gtk.h>
#include <time.h>

#define TOP_MGN 4
#define LEFT_MGN 50
#define RIGHT_MGN 4
#define GAP 8
#define BOTTOM_MGN 28

class Main;
class Iface;
class Interface;
class Router;
class Graph
{
	public:
		Graph(Main *m);
		~Graph();

		void create();
		void show();
		void hide();
		void init();
		void spinner();
		void scroll();
		void router();
		void load();
		void draw();
		void draw_line(int l, GdkColor *col, int scale);
		void get_speed();
		void select_interface(char *str);
		void select_interface2(char *str);

		Main *main;
		gint width, height;
		GdkPixmap *canvas;
		char current_file[256];
		Iface *iface;
		int size;	// num entries in array
		int BX, BY, BW, BH;
		int SX, SY, SW, SH;
		unsigned long speed;

		// offset in days from today (0)
		int start_graph, length;

		// working variables
		time_t gstart, gend, gtmp, gtmp2;

		Router *current_router;
		Interface *current_interface;

//	private:
		GdkGC *gc;
		GdkGC *gridgc;

  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *vbox20;
  GtkWidget *vbox27;
  GtkWidget *vbox28;
  GtkWidget *vbox31;
  GtkWidget *drawingarea1;
  GtkWidget *hbox1;
  GtkWidget *table4;
  GtkWidget *checkbutton13;
  GtkWidget *checkbutton14;
  GtkWidget *checkbutton15;
  GtkWidget *checkbutton16;
  GtkWidget *checkbutton17;
  GtkWidget *checkbutton18;
  GtkWidget *checkbutton19;
  GtkWidget *checkbutton20;
  GtkWidget *button39;
  GtkWidget *scrolledwindow23;
  GtkWidget *clist22;
  GtkWidget *scrolledwindow24;
  GtkWidget *clist23;
  GtkWidget *hscrollbar5;
  GtkWidget *combo3;
  GtkWidget *combo_entry2;
  GtkWidget *combo4;
  GtkWidget *combo_entry3;
	GList *combo1_items;

  GtkWidget *hscale2;
  GtkWidget *hbox2;
  GtkWidget *hbox46;
	GtkObject *hscrollbar2_adj;
  GtkWidget *hscrollbar2;
  GtkObject *spinbutton4_adj;
  GtkWidget *spinbutton4;
  GtkWidget *frame5;
  GtkWidget *frame6;
  GtkWidget *frame7;
  GtkWidget *frame8;
  GtkWidget *frame12;
  GtkWidget *hbox3;
  GtkWidget *hbox32;
  GtkWidget *hbox33;
  GtkWidget *scrolledwindow25;
  GtkWidget *clist24;

	GtkWidget *pixmap3;
	GtkWidget *pixmap4;
	GtkWidget *pixmap5;
	GtkWidget *pixmap6;
	GtkWidget *pixmap7;
	GtkWidget *pixmap8;
	GtkWidget *pixmap9;
	GtkWidget *pixmap10;
	GdkPixmap *weekendpixmap;
};

#endif

