/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef HELP_H
#define HELP_H 1

#include <gtk/gtk.h>
#define MAX_HLINK 256
#define MAX_GO 256

class HLink
{
	public:
		int x, y, w, h;
		char fname[64];
};

class Main;
class Help
{
	public:
		Help(Main *m);
		~Help();

		void create();
		void show();
		void hide();
		void draw();
		void resize();
		void load();
		void check_link(int x, int y);
		void move_link(int x, int y);
		void home_cb();
		void back_cb();
		void forward_cb();

		void ok_sel();

		Main *main;
		gint width, height;
		GdkPixmap *canvas;
		GdkGC *gc;
		char help_dir[256];
		char help_file[256];
		HLink link[MAX_HLINK];
		int num_hlink;
		char go_list[64][MAX_GO];
		int num_go, current_go;
		gint context_id;

	private:
		GtkWidget *window1;
		GtkWidget *vbox1;
		GtkWidget *menubar1;
		GtkWidget *File;
		GtkWidget *menu2;
		GtkWidget *Close;
		GtkWidget *Home;
		GtkWidget *Back;
		GtkWidget *Forward;
		GtkWidget *toolbar1;
		GtkWidget *scrolledwindow1;
		GtkWidget *drawingarea1;
		GtkWidget *statusbar1;
		GdkCursor *hand_cursor;
		GdkCursor *arrow_cursor;
};

#endif

