/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef MAIN_H
#define MAIN_H 1

#include "help.h"
#include "graph.h"
#include "monitor.h"
#include "filesel.h"
#include "files.h"
#include "common.h"
#include "print.h"
#include "search.h"
#include "pref.h"
#include "machinewindow.h"
#include "subnetwindow.h"
#include "devicewindow.h"
#include "bounds.h"
#include "filterwindow.h"

class Main
{
	public:
		Main();
		~Main();

		void run();
		void timeout();
		void init_timeout();
		void quit();
		void alloc_color(GdkColor &col, guint16 r, guint16 g, guint16 b);

		Help *help;
		Monitor *monitor;
		FileSel *filesel;
		Files *files;
		Print *print;
		Search *search;
		Pref *pref;
		MachineWindow *machine;
		SubnetWindow *subnet;
		DeviceWindow *device;
		Bounds *bounds;
		FilterWindow *filter;

		GdkFont *font8m, *font10m, *font12m, *font18m, *font24m;
		GdkFont *font8b, *font10b, *font12b, *font18b, *font24b;
		GdkColor red, darkred, green, darkgreen, blue, darkblue;
		GdkColor cyan, darkcyan, magenta, darkmagenta, yellow, darkyellow;
		GdkColor lightgray, gray, darkgray;
		GdkColor black, white, orange, purple;
		GdkColormap *colormap;
};

#endif

