/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "main.h"
#include "diagram.h"
#include "machine.h"
#include "interface.h"
#include "network.h"
#include "subnet.h"
#include "router.h"
#include "images/open.xpm"
#include "images/save.xpm"
#include "images/print.xpm"
#include "images/exec.xpm"
#include "images/machine.xpm"
#include "images/network.xpm"
#include "images/icon.xpm"

void Monitor::del()
{
	if (((GtkCList*)clist18)->selection != NULL)
		gtk_clist_remove((GtkCList*)clist18, row);
}

void Monitor::add()
{
	gchar *data[2];
	gchar *tmp;
	char buf[256];
	char ip[64];
	int a, b, c, d;
	int e, f, g, h;
	int r, type;

	tmp = gtk_entry_get_text(GTK_ENTRY(entry5));
	strcpy(buf, tmp);
	if (strcmp(buf, "")!=0)
	{
		// parse the text entry
		if (sscanf(buf, "%d.%d.%d.%d %d.%d.%d.%d", &a, &b, &c, &d, &e, &f, &g, &h)==8)
		{
			type = 2;
			e = 0;		// convert mask here
			sprintf(ip, "%d.%d.%d.%d/%d", a, b, c, d, e);
			data[0] = strdup("n");
			data[1] = strdup(ip);
		}else
		if (sscanf(buf, "%d.%d.%d.%d %d", &a, &b, &c, &d, &e)==5)
		{
			type = 2;
			sprintf(ip, "%d.%d.%d.%d/%d", a, b, c, d, e);
			data[0] = strdup("n");
			data[1] = strdup(ip);
		}else
		if (sscanf(buf, "%d.%d.%d.%d/%d", &a, &b, &c, &d, &e)==5)
		{
			type = 2;
			data[0] = strdup("n");
			data[1] = strdup(buf);
		}else
		if (sscanf(buf, "%d.%d.%d.%d", &a, &b, &c, &d)==4)
		{
			type = 1;
			sprintf(ip, "%d.%d.%d.%d", a, b, c, d);
			data[0] = strdup("m");
			data[1] = strdup(ip);
		}else
		{
			type = 1;
			data[0] = strdup("m");
			data[1] = strdup(buf);
		}

		r = gtk_clist_append((GtkCList*)clist18, data);
		delete data[0];	delete data[1];
		if (type == 1)
			clist_pixmap(window1, (GtkCList*)clist18, r, 0, machine_xpm);
		else
			clist_pixmap(window1, (GtkCList*)clist18, r, 0, network_xpm);
	}
	gtk_entry_set_text(GTK_ENTRY(entry5), "");
}

static void list_cb(GtkWidget *clist, gint row, gint column, GdkEventButton *event, gpointer data)
{ Monitor *m = (Monitor*) data; m->row = row; }

static void list_key_cb(GtkWidget *w, GdkEventKey *event, gpointer data)
{ if (event->keyval == 0xffff) ((Monitor*)data)->del(); }

static void on_Load_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->filesel->load(); }
static void on_Save_activate(GtkWidget *w, gpointer data)
{ }
static void on_SaveAs_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->filesel->saveas(); }
static void on_Print_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->print->show(); }
static void on_Exit_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->quit(); }

static void on_Select_All_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->select_all(1); }
static void on_Bounds_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->bounds->show(); }
static void on_Device_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->device->show(); }

static void on_Machine_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	m->main->machine->machine_list = &(m->main->files->objects->machines);
	m->main->machine->show();
}
static void on_Subnet_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->subnet->show(); }
static void on_Preference_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->pref->show(); }

static void star_cb(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->files->star(); ((Monitor*)data)->draw(); }
static void bunch_cb(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->files->bunch(); ((Monitor*)data)->draw(); }

static gint animate_cb(gpointer data)
{ ((Monitor*)data)->diagram->autoplace(); return TRUE; }
static gint ants_cb(gpointer data)
{
	Monitor *m = (Monitor*)data;
	if (m->mode==-1)	// don't animate during a drag operation
	{
		m->animate_frame++;
		if (m->animate_frame>7) m->animate_frame = 0;
		m->draw();
	}
	return TRUE;
}

static void on_Index_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->help->show(); }
static void on_cloud1_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->cloud(0); }
static void on_cloud2_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->cloud(1); }

static void on_cloud3_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->cloud(2); }
static void on_cloud1a_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->clouda(0); }
static void on_cloud2a_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->clouda(1); }
static void on_cloud3a_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->clouda(2); }
static void search_callback(GtkWidget *widget, gpointer data)
{
	gtk_entry_set_text(GTK_ENTRY(((Monitor*)data)->main->search->entry2),
		gtk_entry_get_text(GTK_ENTRY(((Monitor*)data)->entry2)));
	((Monitor*)data)->main->search->show();
	((Monitor*)data)->main->search->apply();
}
static void scroll_cb(GtkWidget *widget, gpointer data)
{ ((Monitor*)data)->draw(); }
static void on_Fit_To_Window_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->fit_to_window(); }
static void fit_to_selected_cb(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->fit_to_selected(); }
static void details_cb(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->details_window(); }
static void machine_cb(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->machine_window(); }
static void graph_cb(GtkWidget *w, gpointer data)
{
	Graph *g = new Graph(((Monitor*)data)->main);

	if (((Monitor*)data)->current != NULL)
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(g->combo3)->entry),
			((Router*)((Monitor*)data)->current)->name);

	g->show();
}
static void graph_cb2(GtkWidget *w, gpointer data)
{
	Graph *g = new Graph(((Monitor*)data)->main);
	Interface *in;
	Network *n;
	Link *ln;
	char buf[256];

	if (((Monitor*)data)->current != NULL)
	{
		n = (Network*) ((Monitor*)data)->current;
		ln = n->interfaces.get_head();
		in = (Interface*) ln->item;
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(g->combo3)->entry),
			in->router->name);
		sprintf(buf, "%s", in->port);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(g->combo4)->entry), buf);
	}
	g->show();
}

static void filter_cb(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->filter->show(); }
static void on_Search_activate(GtkWidget *w, gpointer data)
{ ((Monitor*)data)->main->search->show(); }

static void on_Animate_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*) data;
	if (m->animate == 0)
	{
		m->animate = 1;
		m->animate_tag = gtk_timeout_add(10, animate_cb, data);
	}else
	{
		m->animate = 0;
		gtk_timeout_remove(m->animate_tag);
	}
}

static void on_Ants_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*) data;
	if (m->ants == 0)
	{
		m->ants = 1;
		m->ants_tag = gtk_timeout_add(500 , ants_cb, data);
	}else
	{
		m->ants = 0;
		gtk_timeout_remove(m->ants_tag);
		m->draw();
	}
}

static void zoom_cb(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	GtkAdjustment *adj = (GtkAdjustment *) m->hscale1_adj;
	m->zoomin(m->zoom, adj->value);
}

static void on_Snap_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	if (m->snap == 1)
		m->snap = 0; else m->snap = 1;
	m->draw();
}

static void on_Grid_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	if (m->grid > 0)
		m->grid = 0; else m->grid = 8;
	m->draw();
}

static void on_Labels_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	if (m->diagram->labels == 1)
		m->diagram->labels = 0; else m->diagram->labels = 1;
	m->draw();
}

static void on_Colours_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	if (m->colours == 1)
		m->colours = 0; else m->colours = 1;
	m->draw();
}

static void on_cloud4_activate(GtkWidget *w, gpointer data)
{
	Monitor *m = (Monitor*)data;
	if (m->showones == 1)
		m->showones = 0; else m->showones = 1;
	m->cloud_ones();
	m->draw();
}

void Monitor::cloud_ones()
{
	Link *ln;
	Network *n;

	if (main->files->objects==NULL) return;

	for (ln=main->files->objects->networks.get_head(); ln!=NULL; ln=ln->next)
	{
		n = (Network*) ln->item;
		if ((n->interfaces.size() < 2) && (showones==0))
			n->show = 0;
		else
			n->show = 1;
	}
}

void Monitor::clouda(int val)
{
	Network *n;
	Link *ln;

	if (current->type == 'n')
	{
		if (current->selected == 0)
		{
			n = (Network*) current;
			n->view = val;
		}else
		{
			for (ln=main->files->objects->networks.get_head(); ln!=NULL; ln=ln->next)
			{
				n = (Network*) ln->item;
				if (n->selected == 1)
					n->view = val;
			}
		}
		draw();
	}
}

void Monitor::cloud(int val)
{
	Link *ln;
	Network *n;

	if (main->files->objects==NULL) return;

	for (ln=main->files->objects->networks.get_head(); ln!=NULL; ln=ln->next)
	{
		n = (Network*) ln->item;
		n->view = val;
	}
	draw();
}

static gint expose_event(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
	Monitor *m = (Monitor*)data;

	if (m->canvas!=NULL)
	{
		gdk_draw_pixmap(widget->window,
			widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
			m->canvas, event->area.x, event->area.y, event->area.x, event->area.y,
			event->area.width, event->area.height);
	}
	return FALSE;
}

static gint configure_event(GtkWidget *widget, GdkEventConfigure *event, gpointer data)
{
	// Hmm the window has been resized so there will be an expose event along
	// in a minute to copy the canvas to the screen, but we need to redraw
	// the canvas

//	printf("CONFIG event\n");
	((Monitor*)data)->draw();
	return TRUE;
}

static gint button_press_event(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	((Monitor*)data)->mouse_stuff(event->type, (int) event->x,
		(int) event->y, event->state, event->button, event->time);
	return TRUE;
}

static gint motion_notify_event(GtkWidget *widget, GdkEventMotion *event, gpointer data)
{
	((Monitor*)data)->mouse_stuff(GDK_MOTION_NOTIFY, (int) event->x,
		(int) event->y, event->state, 0, event->time);
	return TRUE;
}

static gint button_release_event(GtkWidget *widget, GdkEventButton *event, gpointer data)
{
	((Monitor*)data)->mouse_stuff(GDK_BUTTON_RELEASE, (int) event->x,
		(int) event->y, event->state, 0, event->time);
	return TRUE;
}

void Monitor::draw_bb(GdkPixmap *w)
{
	gdk_draw_line(w, xgc, obx, oby, bbx, oby);
	gdk_draw_line(w, xgc, obx, oby, obx, bby);
	gdk_draw_line(w, xgc, bbx, oby, bbx, bby);
	gdk_draw_line(w, xgc, obx, bby, bbx, bby);
}

// There are three modes of operation for mouse events
// 0 - no items are selected so we draw a bounding box
// 1 - we selected a single item which we will drag
// 2 - we selected an additional item

void Monitor::mouse_stuff(GdkEventType type, int x, int y, int state, int bttn, guint32 time)
{
	Router *r;
	Network *n;
	int i;
	Link *l;
//	int dblclk = 0;
	int orgx, orgy, tmpx, tmpy;
	GtkAdjustment *adj1, *adj2;

	adj1 = GTK_ADJUSTMENT(main->monitor->adjw);
	adj2 = GTK_ADJUSTMENT(main->monitor->adjh);

	orgx = (int) (adj1->value);
	orgy = (int) (adj2->value);

	if (main->files->objects==NULL) return;

//	if (type == GDK_2BUTTON_PRESS) dblclk = 1;

	if ((type == GDK_BUTTON_PRESS) || (type == GDK_2BUTTON_PRESS))
	{
		gdk_pointer_grab (drawingarea2->window, FALSE, (GdkEventMask) (GDK_POINTER_MOTION_MASK | GDK_BUTTON_RELEASE_MASK), NULL, NULL, time);

		button = bttn;
		mode = 0;

		// see if we clicked on a device
		for (l = main->files->objects->routers.get_tail(); l!=NULL; l=l->prev)
		{
			r = (Router*) l->item;
			if ((r->show == 1) &&
					(((r->x)*zoom)-orgx <= x) && (((r->x + r->w)*zoom)-orgx >= x) &&
					(((r->y)*zoom)-orgy <= y) && (((r->y + r->h)*zoom)-orgy >= y))
			{
				if (mode == 0) current = r;
				mode = 1;
				if (state & GDK_SHIFT_MASK) mode = 2;
			}
		}

		// now see if we clicked on a cloud
		for (l = main->files->objects->networks.get_tail(); l!=NULL; l=l->prev)
		{
			n = (Network*) l->item;
			if ((n->show==1) && // (n->interfaces.size() + n->machines.size() > 1) &&
					(((n->x)*zoom)-orgx <= x) && (((n->x + n->w)*zoom)-orgx >= x) &&
					(((n->y)*zoom)-orgy <= y) && (((n->y + n->h)*zoom)-orgy >= y))
			{
				if (mode == 0) current = n;
				mode = 1;
				if (state & GDK_SHIFT_MASK) mode = 2;
			}
		}

//		if ((mode == 1) && (current!=NULL) && (dblclk==1)) main->details->show();

		// bounding box
		if ((button == 1) && (mode == 0))
		{
			obx = bbx = x;
			oby = bby = y;
			draw_bb(drawingarea2->window);
		}else
		// drag object
		if ((button == 1) && (mode == 1))
		{
			nx = ox = x;
			ny = oy = y;
			if (current->selected == 0)
			{
				// move current
				current->fix = 1;
				gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
						int((current->x*zoom)-orgx), int((current->y*zoom)-orgy),
						int(current->w*zoom), int(current->h*zoom));
			}else
			{
				// move all selected objects
				l = main->files->objects->routers.get_head();
				while (l!=NULL)
				{
					r = (Router*) l->item;
					if ((r->show == 1) && (r->selected == 1))
					{
						r->fix = 1;
						gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
							int((r->x*zoom)-orgx), int((r->y*zoom)-orgy),
							int(r->w*zoom), int(r->h*zoom));
					}
					l = l->next;
				}
				l = main->files->objects->networks.get_head();
				while (l!=NULL)
				{
					n = (Network*) l->item;
					if ((n->show==1) && // (n->interfaces.size() > 1) &&
							(n->selected == 1))
					{
						n->fix = 1;
						gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
							int((n->x*zoom)-orgx), int((n->y*zoom)-orgy),
							int(n->w*zoom), int(n->h*zoom));
					}
					l = l->next;
				}
			}
		}else
		// popup menu
		if ((button == 3) && (mode == 1))
		{
     	if ((current->type == 'r') || (current->type == 's') || (current->type == 'u'))
				gtk_menu_popup(GTK_MENU(popup), NULL, NULL, NULL, NULL, bttn, 0);
			else
     	if (current->type == 'n')
			{
				gtk_menu_popup(GTK_MENU(popup2), NULL, NULL, NULL, NULL, bttn, 0);
			}
		}else
		if ((button == 3) && (mode == 0))
		{
			gtk_menu_popup(GTK_MENU(popup3), NULL, NULL, NULL, NULL, bttn, 0);
		}
	}else
	if (type == GDK_MOTION_NOTIFY)
	{
		if ((button == 1) && (mode == 0))
		{
			draw_bb(drawingarea2->window);
			bbx = x;
			bby = y;
			draw_bb(drawingarea2->window);
		}else
		if ((button == 1) && (mode == 1))
		{
			// r->x, r->y the original position in world coordinates
			// x, y the current mouse position
			// ox, oy the original mouse position before drag
			// nx, ny the mouse position last frame during drag

			// move all selected objects
			if (current->selected == 0)
			{
				gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
					int((current->x*zoom)-ox+nx-orgx), int((current->y*zoom)-oy+ny-orgy),
					int(current->w*zoom), int(current->h*zoom));
				current->x = current->x+((x-ox)/zoom);
				current->y = current->y+((y-oy)/zoom);
				gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
					int((current->x*zoom)-orgx), int((current->y*zoom)-orgy),
					int(current->w*zoom), int(current->h*zoom));
			}else
			{
				l = main->files->objects->routers.get_head();
				while (l!=NULL)
				{
					r = (Router*) l->item;
					if (r->selected == 1)
					{
						gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
							int((r->x*zoom)-ox+nx-orgx), int((r->y*zoom)-oy+ny-orgy),
							int(r->w*zoom), int(r->h*zoom));
						r->x = r->x+((x-ox)/zoom);
						r->y = r->y+((y-oy)/zoom);
						gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
							int((r->x*zoom)-orgx), int((r->y*zoom)-orgy),
							int(r->w*zoom), int(r->h*zoom));
					}
					l = l->next;
				}
				l = main->files->objects->networks.get_head();
				while (l!=NULL)
				{
					n = (Network*) l->item;
					if (n->selected == 1)
					{
						gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
							int((n->x*zoom)-ox+nx-orgx), int((n->y*zoom)-oy+ny-orgy),
							int(n->w*zoom), int(n->h*zoom));
						n->x = n->x+((x-ox)/zoom);
						n->y = n->y+((y-oy)/zoom);
						gdk_draw_rectangle(drawingarea2->window, xgc, FALSE,
							int((n->x*zoom)-orgx), int((n->y*zoom)-orgy),
							int(n->w*zoom), int(n->h*zoom));
					}
					l = l->next;
				}
			}
			ox = x;
			oy = y;
			nx = x;
			ny = y;
		}
	}else
	if (type == GDK_BUTTON_RELEASE)
	{
		if ((button == 1) && (mode == 0))
		{
			// if we are not shift clicking we must deselect everything first
			if (!(state & GDK_SHIFT_MASK))
			{
				l = main->files->objects->routers.get_head();
				while (l!=NULL)
				{
					r = (Router*) l->item;
					r->selected = 0;
					l=l->next;
				}
				l = main->files->objects->networks.get_head();
				while (l!=NULL)
				{
					n = (Network*) l->item;
					n->selected = 0;
					l = l->next;
				}
			}

			// make sure obx,oby is the top left corner
			if (obx>bbx) { i = bbx; bbx = obx; obx = i; }
			if (oby>bby) { i = bby; bby = oby; oby = i; }

			// select those in the bounding box
			l = main->files->objects->routers.get_head();
			while (l!=NULL)
			{
				r = (Router*) l->item;
				if ((r->show == 1) &&
						(obx <= ((r->x)*zoom)-orgx) && (bbx >= ((r->x+r->w)*zoom)-orgx) &&
						(oby <= ((r->y*zoom)-orgy)) && (bby >= ((r->y+r->h)*zoom)-orgy))
					r->selected = 1;
				l = l->next;
			}
			l = main->files->objects->networks.get_head();
			while (l!=NULL)
			{
				n = (Network*) l->item;
				if ((n->show==1) && // (n->interfaces.size() > 1) &&
						(obx <= ((n->x)*zoom)-orgx) && (bbx >= ((n->x+n->w)*zoom)-orgx) &&
						(oby <= ((n->y*zoom)-orgy)) && (bby >= ((n->y+n->h)*zoom)-orgy))
					n->selected = 1;
				l = l->next;
			}
		}else
		if ((button == 1) && (mode == 1))
		{
			if (current->selected == 0)
			{
				// deselect everything else
				l = main->files->objects->routers.get_head();
				while (l!=NULL)
				{
					r = (Router*) l->item;
					r->selected = 0;
					l = l->next;
				}
				l = main->files->objects->networks.get_head();
				while (l!=NULL)
				{
					n = (Network*) l->item;
					n->selected = 0;
					l = l->next;
				}
				// now select current object
				current->selected = 1;
			}

			// adjust location for dropped objects when snap
			l = main->files->objects->routers.get_head();
			while (l!=NULL)
			{
				r = (Router*) l->item;
				r->fix = 0;
				if (r->selected == 1)
				{
					r->x = r->x+((x-ox)/zoom);
					r->y = r->y+((y-oy)/zoom);
					if (snap == 1)
					{
						tmpx = (int) (r->x);
						tmpy = (int) (r->y);
						tmpx = ((tmpx+(GRID_SIZE/2))/GRID_SIZE)*GRID_SIZE;
						tmpy = ((tmpy+(GRID_SIZE/2))/GRID_SIZE)*GRID_SIZE;
						r->x = tmpx;
						r->y = tmpy;
					}
				}
				l = l->next;
			}
			l = main->files->objects->networks.get_head();
			while (l!=NULL)
			{
				n = (Network*) l->item;
				n->fix = 0;
				if (n->selected == 1)
				{
					n->x = n->x+((x-ox)/zoom);
					n->y = n->y+((y-oy)/zoom);
				
					if (snap == 1)
					{
						tmpx = (int) (n->x);
						tmpy = (int) (n->y);
						tmpx = ((tmpx+(GRID_SIZE/2))/GRID_SIZE)*GRID_SIZE;
						tmpy = ((tmpy+(GRID_SIZE/2))/GRID_SIZE)*GRID_SIZE;
						n->x = tmpx;
						n->y = tmpy;
					}
				}
				l = l->next;
			}

			// lower current object so shown last (on top)
			if (current->type=='n')
				main->files->objects->networks.lower(current);
			else
				main->files->objects->routers.lower(current);
		}else
		if ((button == 1) && (mode == 2))							// select
		{
			if ((current->x <= x) && (current->x + current->w >= x) &&
					(current->y <= y) && (current->y + current->h >= y))
			{
				if (current->selected == 0)
					current->selected = 1;
				else
					current->selected = 0;
			}
		}
		mode = -1;
		gdk_pointer_ungrab(GDK_CURRENT_TIME);
		draw();
		button = 0;
	}
}

void Monitor::select_all(int val)
{
	Link *ln;
	Router *r;
	Network *n;

	if (main->files->objects==NULL) return;

	for (ln = main->files->objects->routers.get_head(); ln!=NULL; ln=ln->next)
	{
		r = (Router*) ln->item;
		if ((r->show==1))
			r->selected = val;
	}

	for (ln = main->files->objects->networks.get_head(); ln!=NULL; ln=ln->next)
	{
		n = (Network*) ln->item;
		if (n->show==1)
			n->selected = val;
	}
	draw();
}

Monitor::Monitor(Main *m)
{
	main = m;
	diagram = new Diagram(m);
	canvas = NULL;
	width = height = 100;
	adjw = adjh = NULL;
	create();
	popup_menu1();
	popup_menu2();
	popup_menu3();
	showones = 1;
	colours = 0;
	grid = 0;
	snap = 0;
	zoom = 1.0;
	vbox18_group = NULL;
	current = NULL;
	animate_frame = 0;
	animate_tag = 0;
	ants_tag = 0;
	mode = -1;

	gc  = gdk_gc_new(window1->window);
	xgc = gdk_gc_new(window1->window);

  gdk_gc_set_line_attributes(gc, 1, GDK_LINE_SOLID, GDK_CAP_BUTT,
		GDK_JOIN_MITER);
  gdk_gc_set_line_attributes(xgc, 1, GDK_LINE_SOLID, GDK_CAP_BUTT,
		GDK_JOIN_MITER);
	gdk_gc_set_function(xgc, GDK_XOR);
	gdk_gc_set_foreground(xgc, &main->black);
}

Monitor::~Monitor()
{
	if (gc) gdk_gc_unref(gc);
	if (xgc) gdk_gc_unref(xgc);
}

void Monitor::popup_menu1()
{
	GtkWidget *mn[4];

	popup = gtk_menu_new();

	mn[0] = gtk_menu_item_new_with_label ("Details");
	mn[1] = gtk_menu_item_new_with_label ("Graph");
	mn[2] = gtk_menu_item_new_with_label ("Bunch");
	mn[3] = gtk_menu_item_new_with_label ("Star");
	gtk_widget_show(mn[0]);
	gtk_widget_show(mn[1]);
	gtk_widget_show(mn[2]);
	gtk_widget_show(mn[3]);
	gtk_container_add(GTK_CONTAINER(popup), mn[0]);
	gtk_signal_connect(GTK_OBJECT(mn[0]), "activate",
		GTK_SIGNAL_FUNC(details_cb), this);

	gtk_container_add(GTK_CONTAINER(popup), mn[1]);
	gtk_signal_connect(GTK_OBJECT(mn[1]), "activate",
		GTK_SIGNAL_FUNC(graph_cb), this);

	gtk_container_add(GTK_CONTAINER(popup), mn[2]);
	gtk_signal_connect(GTK_OBJECT(mn[2]), "activate",
		GTK_SIGNAL_FUNC(bunch_cb), this);

	gtk_container_add(GTK_CONTAINER(popup), mn[3]);
	gtk_signal_connect(GTK_OBJECT(mn[3]), "activate",
		GTK_SIGNAL_FUNC(star_cb), this);
}

void Monitor::popup_menu2()
{
	GtkWidget *mn[5];

	popup2 = gtk_menu_new();

	mn[0] = gtk_menu_item_new_with_label ("Details");
	mn[1] = gtk_menu_item_new_with_label ("Graph");
	mn[2] = gtk_menu_item_new_with_label ("Blob");
	mn[3] = gtk_menu_item_new_with_label ("Subnet");
	mn[4] = gtk_menu_item_new_with_label ("Machine");
	gtk_widget_show(mn[0]);
	gtk_widget_show(mn[1]);
	gtk_widget_show(mn[2]);
	gtk_widget_show(mn[3]);
	gtk_widget_show(mn[4]);
	gtk_container_add(GTK_CONTAINER(popup2), mn[0]);
	gtk_container_add(GTK_CONTAINER(popup2), mn[1]);
	gtk_container_add(GTK_CONTAINER(popup2), mn[2]);
	gtk_container_add(GTK_CONTAINER(popup2), mn[3]);
	gtk_container_add(GTK_CONTAINER(popup2), mn[4]);
	gtk_signal_connect(GTK_OBJECT(mn[0]), "activate",
		GTK_SIGNAL_FUNC(machine_cb), this);
	gtk_signal_connect(GTK_OBJECT(mn[1]), "activate",
		GTK_SIGNAL_FUNC(graph_cb2), this);
	gtk_signal_connect(GTK_OBJECT(mn[2]), "activate",
		GTK_SIGNAL_FUNC(on_cloud1a_activate), this);
	gtk_signal_connect(GTK_OBJECT(mn[3]), "activate",
		GTK_SIGNAL_FUNC(on_cloud2a_activate), this);
	gtk_signal_connect(GTK_OBJECT(mn[4]), "activate",
		GTK_SIGNAL_FUNC(on_cloud3a_activate), this);
}

void Monitor::popup_menu3()
{
	GtkWidget *mn[3];

	popup3 = gtk_menu_new();
	mn[1] = gtk_menu_item_new_with_label ("Fit to Window");
	mn[2] = gtk_menu_item_new_with_label ("Fit to Selected");
	gtk_widget_show(mn[1]);
	gtk_widget_show(mn[2]);
	gtk_container_add(GTK_CONTAINER(popup3), mn[1]);
	gtk_container_add(GTK_CONTAINER(popup3), mn[2]);
	gtk_signal_connect(GTK_OBJECT(mn[1]), "activate",
		GTK_SIGNAL_FUNC(on_Fit_To_Window_activate), this);
	gtk_signal_connect(GTK_OBJECT(mn[2]), "activate",
		GTK_SIGNAL_FUNC(fit_to_selected_cb), this);
}

void Monitor::create()
{
	int i;

  window1 = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (window1, 640, 480);
  gtk_window_set_title(GTK_WINDOW (window1), "Network Monitor");
  gtk_widget_realize (window1);
	window_icon(window1, icon_xpm);

  pixmap[1] = create_pixmap(window1, open_xpm);
  pixmap[2] = create_pixmap(window1, save_xpm);
  pixmap[3] = create_pixmap(window1, print_xpm);
  pixmap[6] = create_pixmap(window1, exec_xpm);

	vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);


  mainmenu[0] = gtk_menu_bar_new ();
  gtk_widget_show (mainmenu[0]);
  gtk_box_pack_start (GTK_BOX (vbox1), mainmenu[0], FALSE, TRUE, 0);
  mainmenu[1] = gtk_menu_item_new_with_label ("File");
  mainmenu[2] = gtk_menu_item_new_with_label ("View");
  mainmenu[3] = gtk_menu_item_new_with_label ("Options");
  mainmenu[4] = gtk_menu_item_new_with_label ("Windows");
  mainmenu[5] = gtk_menu_item_new_with_label ("Help");
	for (i=1; i<=5; i++)
	{
		gtk_widget_show(mainmenu[i]);
		gtk_container_add(GTK_CONTAINER(mainmenu[0]), mainmenu[i]);
	}
  gtk_menu_item_right_justify (GTK_MENU_ITEM (mainmenu[5]));


  filemenu[0] = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainmenu[1]), filemenu[0]);
  filemenu[1] = gtk_menu_item_new_with_label ("Open...");
  filemenu[2] = gtk_menu_item_new_with_label ("Save");
  filemenu[3] = gtk_menu_item_new_with_label ("Save As...");
  filemenu[4] = gtk_menu_item_new            ();
  filemenu[5] = gtk_menu_item_new_with_label ("Print");
  filemenu[6] = gtk_menu_item_new            ();
  filemenu[7] = gtk_menu_item_new_with_label ("Exit");
	for (i=1; i<=7; i++)
	{
		gtk_widget_show(filemenu[i]);
		gtk_container_add(GTK_CONTAINER(filemenu[0]), filemenu[i]);
	}
  gtk_signal_connect(GTK_OBJECT(filemenu[1]), "activate",
		GTK_SIGNAL_FUNC(on_Load_activate), this);
  gtk_signal_connect(GTK_OBJECT(filemenu[2]), "activate",
		GTK_SIGNAL_FUNC(on_Save_activate), this);
  gtk_signal_connect(GTK_OBJECT(filemenu[3]), "activate",
		GTK_SIGNAL_FUNC(on_SaveAs_activate), this);
  gtk_signal_connect(GTK_OBJECT(filemenu[5]), "activate",
		GTK_SIGNAL_FUNC(on_Print_activate), this);
  gtk_signal_connect(GTK_OBJECT(filemenu[7]), "activate",
		GTK_SIGNAL_FUNC(on_Exit_activate), this);


  viewmenu[0] = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainmenu[2]), viewmenu[0]);
  viewmenu[1] = gtk_menu_item_new_with_label ("Select All");
  viewmenu[2] = gtk_menu_item_new_with_label ("Fit To Window");
  viewmenu[3] = gtk_menu_item_new_with_label ("Network");
  viewmenu[4] = gtk_menu_item_new_with_label ("Bunch");
  viewmenu[5] = gtk_menu_item_new_with_label ("Star");
  viewmenu[6] = gtk_menu_item_new_with_label ("Fit To Selected");
	for (i=1; i<=6; i++)
	{
		gtk_widget_show(viewmenu[i]);
		gtk_container_add(GTK_CONTAINER(viewmenu[0]), viewmenu[i]);
	}
  gtk_signal_connect(GTK_OBJECT(viewmenu[1]), "activate",
		GTK_SIGNAL_FUNC(on_Select_All_activate), this);
  gtk_signal_connect(GTK_OBJECT(viewmenu[2]), "activate",
		GTK_SIGNAL_FUNC(on_Fit_To_Window_activate), this);
  gtk_signal_connect(GTK_OBJECT(viewmenu[4]), "activate",
		GTK_SIGNAL_FUNC(bunch_cb), this);
  gtk_signal_connect(GTK_OBJECT(viewmenu[5]), "activate",
		GTK_SIGNAL_FUNC(star_cb), this);
  gtk_signal_connect(GTK_OBJECT(viewmenu[6]), "activate",
		GTK_SIGNAL_FUNC(fit_to_selected_cb), this);


	netwmenu[0] = gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (viewmenu[3]), netwmenu[0]);
	netwmenu[1] = gtk_menu_item_new_with_label ("Cloud");
	netwmenu[2] = gtk_menu_item_new_with_label ("Subnets");
	netwmenu[3] = gtk_menu_item_new_with_label ("Machines");
	for (i=1; i<=3; i++)
	{
		gtk_widget_show(netwmenu[i]);
		gtk_container_add(GTK_CONTAINER(netwmenu[0]), netwmenu[i]);
	}
  gtk_signal_connect(GTK_OBJECT(netwmenu[1]), "activate",
		GTK_SIGNAL_FUNC(on_cloud1_activate), this);
  gtk_signal_connect(GTK_OBJECT(netwmenu[2]), "activate",
		GTK_SIGNAL_FUNC(on_cloud2_activate), this);
  gtk_signal_connect(GTK_OBJECT(netwmenu[3]), "activate",
		GTK_SIGNAL_FUNC(on_cloud3_activate), this);


	optnmenu[0] = gtk_menu_new();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainmenu[3]), optnmenu[0]);
	optnmenu[1] = gtk_check_menu_item_new_with_label ("Labels");
	optnmenu[2] = gtk_check_menu_item_new_with_label ("Grid");
	optnmenu[3] = gtk_check_menu_item_new_with_label ("Snap");
	optnmenu[4] = gtk_check_menu_item_new_with_label ("Colours");
	optnmenu[5] = gtk_check_menu_item_new_with_label ("None");
	optnmenu[6] = gtk_menu_item_new();
	optnmenu[7] = gtk_check_menu_item_new_with_label ("Traffic");

	for (i=1; i<=7; i++)
	{
		gtk_widget_show(optnmenu[i]);
		gtk_container_add(GTK_CONTAINER(optnmenu[0]), optnmenu[i]);
	}
  gtk_signal_connect (GTK_OBJECT (optnmenu[1]), "activate",
		GTK_SIGNAL_FUNC (on_Labels_activate), this);
  gtk_signal_connect (GTK_OBJECT (optnmenu[2]), "activate",
		GTK_SIGNAL_FUNC (on_Grid_activate), this);
  gtk_signal_connect (GTK_OBJECT (optnmenu[3]), "activate",
		GTK_SIGNAL_FUNC (on_Snap_activate), this);
  gtk_signal_connect (GTK_OBJECT (optnmenu[4]), "activate",
		GTK_SIGNAL_FUNC (on_Colours_activate), this);
  gtk_signal_connect (GTK_OBJECT (optnmenu[5]), "activate",
		GTK_SIGNAL_FUNC (on_cloud4_activate), this);
  gtk_signal_connect (GTK_OBJECT (optnmenu[7]), "activate",
		GTK_SIGNAL_FUNC (on_Ants_activate), this);


  wndwmenu[0] = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainmenu[4]), wndwmenu[0]);
	wndwmenu[1] = gtk_menu_item_new_with_label ("Network Bounds");
	wndwmenu[2] = gtk_menu_item_new_with_label ("Device Details");
	wndwmenu[3] = gtk_menu_item_new_with_label ("Machine Details");
	wndwmenu[4] = gtk_menu_item_new_with_label ("Subnet Details");
	wndwmenu[5] = gtk_menu_item_new_with_label ("Search");
	wndwmenu[6] = gtk_menu_item_new_with_label ("Graph");
	wndwmenu[7] = gtk_menu_item_new_with_label ("Filter");
  wndwmenu[8] = gtk_menu_item_new            ();
	wndwmenu[9] = gtk_menu_item_new_with_label ("Preferences");
	for (i=1; i<=9; i++)
	{
		gtk_widget_show(wndwmenu[i]);
		gtk_container_add(GTK_CONTAINER(wndwmenu[0]), wndwmenu[i]);
	}
  gtk_signal_connect (GTK_OBJECT (wndwmenu[1]), "activate",
		GTK_SIGNAL_FUNC (on_Bounds_activate), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[2]), "activate",
		GTK_SIGNAL_FUNC (on_Device_activate), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[3]), "activate",
		GTK_SIGNAL_FUNC (on_Machine_activate), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[4]), "activate",
		GTK_SIGNAL_FUNC (on_Subnet_activate), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[5]), "activate",
		GTK_SIGNAL_FUNC (on_Search_activate), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[6]), "activate",
		GTK_SIGNAL_FUNC (graph_cb), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[7]), "activate",
		GTK_SIGNAL_FUNC (filter_cb), this);
  gtk_signal_connect (GTK_OBJECT (wndwmenu[9]), "activate",
		GTK_SIGNAL_FUNC (on_Preference_activate), this);


  helpmenu[0] = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (mainmenu[5]), helpmenu[0]);
	helpmenu[1] = gtk_menu_item_new_with_label ("Index");
	for (i=1; i<=1; i++)
	{
		gtk_widget_show(helpmenu[i]);
		gtk_container_add(GTK_CONTAINER(helpmenu[0]), helpmenu[i]);
	}
  gtk_signal_connect (GTK_OBJECT (helpmenu[1]), "activate",
		GTK_SIGNAL_FUNC (on_Index_activate), this);

  hbox13 = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (hbox13);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox13, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox13), 4);

  vbox17 = gtk_vbox_new (FALSE, 4);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox13), vbox17, FALSE, FALSE, 0);

  toolbar3 = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS);
  gtk_widget_show (toolbar3);
  gtk_box_pack_start (GTK_BOX (vbox17), toolbar3, FALSE, FALSE, 0);
  gtk_toolbar_set_space_size (GTK_TOOLBAR (toolbar3), 4);

  button2 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3), GTK_TOOLBAR_CHILD_BUTTON, NULL, "button2", "Open View", NULL, pixmap[1], GTK_SIGNAL_FUNC(on_Load_activate), this);
  gtk_widget_show (button2);

  button3 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3), GTK_TOOLBAR_CHILD_BUTTON, NULL, "button3", "Save View", NULL, pixmap[2], GTK_SIGNAL_FUNC(on_Save_activate), this);
  gtk_widget_show (button3);

	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar3));
 
 button6 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3), GTK_TOOLBAR_CHILD_BUTTON, NULL, "button3", "Print", NULL, pixmap[3], GTK_SIGNAL_FUNC(on_Print_activate), this);
  gtk_widget_show (button6);

  button9 = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar3), GTK_TOOLBAR_CHILD_BUTTON, NULL, "button9", "Auto Placement", NULL, pixmap[6], GTK_SIGNAL_FUNC(on_Animate_activate), this);
  gtk_widget_show (button9);

  frame4 = gtk_frame_new (NULL);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (vbox17), frame4, FALSE, TRUE, 0);

	hbox52 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox52);
	gtk_container_add (GTK_CONTAINER (frame4), hbox52);

  label34 = gtk_label_new ("Routers 0\nSwitches 0\nMachines 0\nSubnets 0");
  gtk_widget_show (label34);
  gtk_box_pack_end (GTK_BOX (hbox52), label34, TRUE, TRUE, 0);
  gtk_misc_set_padding (GTK_MISC (label34), 4, 4);

	frame2 = gtk_frame_new ("Zoom");
	gtk_widget_show (frame2);
	gtk_box_pack_start (GTK_BOX (vbox17), frame2, FALSE, TRUE, 0);

	hbox16 = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox16);
	gtk_container_add (GTK_CONTAINER (frame2), hbox16);
	gtk_container_set_border_width (GTK_CONTAINER (hbox16), 4);

  hscale1_adj = gtk_adjustment_new (1.0, 0.2, 5.0, 0.1, 0.1, 0.5);
  hscale1 = gtk_hscale_new (GTK_ADJUSTMENT (hscale1_adj));
  gtk_widget_show (hscale1);
  gtk_box_pack_start (GTK_BOX (hbox16), hscale1, TRUE, TRUE, 0);
  gtk_scale_set_draw_value (GTK_SCALE (hscale1), FALSE);
	gtk_signal_connect (GTK_OBJECT (hscale1_adj), "value_changed",
		GTK_SIGNAL_FUNC (zoom_cb), this);

  frame1 = gtk_frame_new ("Search");
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox17), frame1, FALSE, TRUE, 0);

  hbox15 = gtk_hbox_new (FALSE, 4);
  gtk_widget_show (hbox15);
  gtk_container_add (GTK_CONTAINER (frame1), hbox15);
  gtk_container_set_border_width (GTK_CONTAINER (hbox15), 4);

  entry2 = gtk_entry_new ();
  gtk_widget_show (entry2);
  gtk_box_pack_start (GTK_BOX (hbox15), entry2, TRUE, TRUE, 0);
  gtk_entry_set_text (GTK_ENTRY (entry2), "");
	gtk_widget_set_usize (entry2, 12, -2);
	gtk_signal_connect(GTK_OBJECT(entry2), "activate",
		GTK_SIGNAL_FUNC(search_callback), this);

  button36 = gtk_button_new_with_label ("OK");
  gtk_widget_show (button36);
  gtk_box_pack_start (GTK_BOX (hbox15), button36, FALSE, FALSE, 0);
  gtk_widget_set_usize (button36, 32, -2);
  gtk_signal_connect (GTK_OBJECT (button36), "clicked",
		GTK_SIGNAL_FUNC (search_callback), this);

  frame3 = gtk_frame_new ("Filter");
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (vbox17), frame3, TRUE, TRUE, 0);

  hbox53 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox53);
  gtk_container_add (GTK_CONTAINER (frame3), hbox53);

  scrolledwindow19 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow19);
  gtk_box_pack_start (GTK_BOX (hbox53), scrolledwindow19, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (scrolledwindow19), 4);
//  gtk_widget_set_usize (scrolledwindow19, 160, 120);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow19), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  clist18 = gtk_clist_new (2);
  gtk_widget_show (clist18);
  gtk_container_add (GTK_CONTAINER (scrolledwindow19), clist18);
  gtk_widget_set_usize (clist18, 120, -2);
  gtk_clist_set_column_width (GTK_CLIST (clist18), 0, 15);
  gtk_clist_set_column_width (GTK_CLIST (clist18), 1, 80);
  gtk_clist_column_titles_hide (GTK_CLIST (clist18));
	gtk_signal_connect(GTK_OBJECT(clist18), "select_row",
		GTK_SIGNAL_FUNC(list_cb), this);
	gtk_signal_connect(GTK_OBJECT(clist18), "key-press-event",
		GTK_SIGNAL_FUNC(list_key_cb), this);

	table1 = gtk_table_new (2, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (hbox13), table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 2);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 2);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 2);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_show (viewport1);
  gtk_table_attach (GTK_TABLE (table1), viewport1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL | GTK_SHRINK),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL | GTK_SHRINK), 0, 0);

  drawingarea2 = gtk_drawing_area_new ();
	gtk_widget_set_events(drawingarea2, GDK_EXPOSURE_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_POINTER_MOTION_MASK );
  gtk_widget_show (drawingarea2);
  gtk_container_add (GTK_CONTAINER (viewport1), drawingarea2);

	adjh = gtk_adjustment_new (0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
	adjw = gtk_adjustment_new (0.0, 0.0, 0.0, 0.0, 0.0, 0.0);

  vscrollbar1 = gtk_vscrollbar_new(GTK_ADJUSTMENT(adjh));
  gtk_widget_show (vscrollbar1);
  gtk_table_attach (GTK_TABLE (table1), vscrollbar1, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL | GTK_SHRINK), 0, 0);

  hscrollbar1 = gtk_hscrollbar_new(GTK_ADJUSTMENT(adjw));
  gtk_widget_show (hscrollbar1);
  gtk_table_attach (GTK_TABLE (table1), hscrollbar1, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL | GTK_SHRINK),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);

	gtk_widget_realize(drawingarea2);

	gtk_signal_connect (GTK_OBJECT (adjw), "value_changed",
		GTK_SIGNAL_FUNC (scroll_cb), this);
	gtk_signal_connect (GTK_OBJECT (adjh), "value_changed",
		GTK_SIGNAL_FUNC (scroll_cb), this);
	gtk_signal_connect (GTK_OBJECT (drawingarea2), "expose_event",
		(GtkSignalFunc) expose_event, this);
	gtk_signal_connect (GTK_OBJECT(drawingarea2),"configure_event",
		(GtkSignalFunc) configure_event, this);
	gtk_signal_connect (GTK_OBJECT (drawingarea2), "motion_notify_event",
		(GtkSignalFunc) motion_notify_event, this);
	gtk_signal_connect (GTK_OBJECT (drawingarea2), "button_press_event",
		(GtkSignalFunc) button_press_event, this);
	gtk_signal_connect (GTK_OBJECT (drawingarea2), "button_release_event",
		(GtkSignalFunc) button_release_event, this);
}

void Monitor::show()
{
	gtk_widget_show(window1);
	gdk_window_raise(window1->window);
	gdk_window_set_icon_name(window1->window, "Monitor");
}

void Monitor::hide()
{
	gtk_widget_hide(window1);
}

// width, height are is screen size
// grid and object coordinates are in data size

void Monitor::draw()
{
	gint ow, oh;
	gint neww, newh;
	GtkAdjustment *adj1, *adj2;

	oh = height;
	ow = width;

	if (viewport1->window == NULL) return;

	// work out current width heights of objects for the current view
	main->files->width_height();

	// work out size needed for diagram
	if (animate==0) diagram->compress(0);

	height = viewport1->allocation.height;
	width = viewport1->allocation.width;
	if (height<100) height = 100;
	if (width<100) width = 100;

	if ((canvas == NULL) || (oh != height) || (ow != width))
	{
		if (canvas) gdk_pixmap_unref(canvas);
	  gtk_widget_set_usize (drawingarea2, width, height);
		canvas = gdk_pixmap_new(drawingarea2->window, width, height, -1);
	}

	// update scrollbars
	adj1 = GTK_ADJUSTMENT(adjw);
	adj1->step_increment = 8;
	adj1->page_increment = width/2;
	adj1->page_size = width;
	adj1->lower = 0;
	adj1->upper = diagram->full_width*zoom;
	gtk_signal_emit_by_name (GTK_OBJECT (adj1), "changed");
	adj2 = GTK_ADJUSTMENT(adjh);
	adj2->step_increment = 8;
	adj2->page_increment = height/2;
	adj2->page_size = height;
	adj2->lower = 0;
	adj2->upper = diagram->full_height*zoom;
	gtk_signal_emit_by_name (GTK_OBJECT (adj2), "changed");

//	if (diagram->full_width*zoom<width)
//		neww = (gint) (-(width - (diagram->full_width*zoom))/2);
//	else
		neww = (gint)(adj1->value);
//	if (diagram->full_height*zoom<height)
//		newh = (gint)(-(height - (diagram->full_height*zoom))/2);
//	else
		newh = (gint)(adj2->value);

	diagram->dodraw(canvas, gc, zoom, width, height, neww, newh, 1);

	// bounding box while animated
	if ((button == 1) && (mode == 0)) draw_bb(canvas);

	// force an expose event
	gdk_draw_pixmap(drawingarea2->window,
		drawingarea2->style->fg_gc[GTK_WIDGET_STATE(drawingarea2)],
		canvas, 0, 0, 0, 0, drawingarea2->allocation.width,
		drawingarea2->allocation.height);
}

/*
	zoom is orig value
	nw is new zoom value

	current_zoomed_width = diagram->full_width*zoom;
	orig_width = diagram->full_width;
	new_zoomed_width = diagram->full_width*nw;

	grown = diagram->full_width*nw - diagram->full_width*zoom
				= diagram->full_width*(nw-zoom);

	visible_grown = width*(nw-zoom);
*/

void Monitor::zoomin(double orig, double nw)
{
	GtkAdjustment *adj1, *adj2;
	int width, height;

	width = viewport1->allocation.width;
	height = viewport1->allocation.height;
	if (width<100) width = 100;
	if (height<100) height = 100;

	adj1 = GTK_ADJUSTMENT(adjw);
	adj2 = GTK_ADJUSTMENT(adjh);

	adj1->value += width*(nw-orig)/2;
	gtk_signal_emit_by_name (GTK_OBJECT(adj1), "changed");

	adj2->value += height*(nw-orig)/2;
	gtk_signal_emit_by_name (GTK_OBJECT(adj2), "changed");
	
	zoom = nw;
	draw();
}

void Monitor::fit_to_window()
{
	double z1, z2;

	diagram->compress(0);

	height = viewport1->allocation.height;
	width = viewport1->allocation.width;

	z1 = (double)(height)/(double)(diagram->full_height);
	z2 = (double)(width)/(double)(diagram->full_width);
	if (z1<z2) zoom = z1; else zoom = z2;
	gtk_adjustment_set_value(GTK_ADJUSTMENT(hscale1_adj), zoom);
	draw();
}

void Monitor::fit_to_selected()
{
	double z1, z2;

	diagram->compress(1);

	height = viewport1->allocation.height;
	width = viewport1->allocation.width;

	z1 = (double)(height)/(double)(diagram->full_height);
	z2 = (double)(width)/(double)(diagram->full_width);
	if (z1<z2) zoom = z1; else zoom = z2;
	gtk_adjustment_set_value(GTK_ADJUSTMENT(hscale1_adj), zoom);
	draw();
}

void Monitor::details_window()
{
	main->device->show();
	main->device->device_string(((Router*)current)->name);
}

void Monitor::machine_window()
{
	main->machine->machine_list = &(((Network*)current)->machines);
	main->machine->show();
}

