/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include <string.h>
#include "filter.h"
#include "misc.h"

FilterEntry::FilterEntry()
{
	strcpy(string, "");
	allow = 0;
}

FilterEntry::~FilterEntry()
{
}

Filter::Filter()
{
	clear();
}

Filter::~Filter()
{
}

void Filter::clear()
{
	FilterEntry *e;
	Link *ln;

	strcpy(name, "");
	for (ln=entries.get_head(); ln!=NULL; ln=ln->next)
	{
		e = (FilterEntry*) ln->item;
		delete e;
	}
	entries.clear();
	include_paths = 0;
}

void Filter::save(FILE *f)
{
	FilterEntry *e;
	Link *ln;
	int i;

	for (i=0; i<64; i++)  fputc(name[i], f);
	write_int(f, entries.size());
	for (ln=entries.get_head(); ln!=NULL; ln=ln->next)
	{
		e = (FilterEntry*) ln->item;
		for (i=0; i<64; i++)  fputc(e->string[i], f);
		write_int(f, e->allow);
	}
	write_int(f, include_paths);
}

void Filter::load(FILE *f)
{
	FilterEntry *e;
	int i, cnt;

	for (i=0; i<64; i++) name[i] = fgetc(f); name[64] = '\0';
	cnt = read_int(f);
	for (i=0; i<cnt; i++)
	{
		e = new FilterEntry();
		for (i=0; i<64; i++) e->string[i] = fgetc(f); e->string[64] = '\0';
		e->allow = read_int(f);
		entries.tag(e);
	}
	include_paths = read_int(f);
}

void Filter::print()
{
	FilterEntry *e;
	Link *ln;

	printf("%s, %d\n", name, include_paths);
	for (ln=entries.get_head(); ln!=NULL; ln=ln->next)
	{
		e = (FilterEntry*) ln->item;
		printf("  %s, %d\n", e->string, e->allow);
	}
}

void Filter::savexml(xmlNodePtr xmlnode)
{
	xmlNodePtr newxml;
	xmlNodePtr cur;
	FilterEntry *e;
	char buf[256];
	Link *ln;

	newxml = xmlNewChild(xmlnode, NULL, (xmlChar*)"Filter", NULL);
	xmlSetProp(newxml, (xmlChar*)"name", (xmlChar*)name);
	for (ln=entries.get_head(); ln!=NULL; ln=ln->next)
	{
		cur = xmlNewChild(newxml, NULL, (xmlChar*)"Entry", NULL);
		e = (FilterEntry*) ln->item;
		xmlSetProp(cur, (xmlChar*)"string", (xmlChar*)e->string);
		sprintf(buf, "%d", e->allow);
		xmlSetProp(cur, (xmlChar*)"allow", (xmlChar*)buf);
	}
}

