/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef LIST_H
#define LIST_H 1

#define BUBBLE_SORT 1

class Link
{
	public:
		Link *next;
		Link *prev;
		void *item;
};

typedef int (*Compare) (Link *a, Link *b);

class List
{
	public:
		List();
		~List();

		void add(void *i);			// add to head of list
		void tag(void *i);			// tag to tail of list
		void del(void *i);			// delete from list
		void clear();						// clear the list
		void raise(void *i);		// raise to head of list
		void lower(void *i);		// lower to tail of list
		void *get_item(int i);

		Link *get_head();
		Link *get_tail();

		int  size();
		void sort(Compare compare, int type);
		void bubblesort(Compare f, Link *low, Link *high);

	private:
		int count;
		Link *first;
		Link *last;
};

#endif

