/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef MISC_H
#define MISC_H 1

#define HOME_DIR ".nomad"

#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>
#include <sys/time.h>
#include <stdio.h>
#include "ipaddress.h"

time_t make_time_from_string(char *buf);
void make_string_from_time(time_t t, char *buf);

int starts_with(char *str, char *bigstr);

void write_int(FILE *f, int val);
void write_ulong(FILE *f, unsigned long val);
void write_time_t(FILE *f, time_t val);

int read_int(FILE *f);
unsigned long read_ulong(FILE *f);
time_t read_time_t(FILE *f);

void convert_mac(char *macin, unsigned char *macout);
void convert_mac_2(char *macin, unsigned char *macout);
void convert_mac_3(char *macin, unsigned char *macout);
int compare_mac(unsigned char *mac1, unsigned char *mac2);
int zero_mac(unsigned char *mac);
void print_mac(unsigned char *buf);
void sprint_mac(unsigned char *buf, char *str);

int mask_num(char *buf);
void print_time(time_t buf);
int mask_power(int pwr);
int in_subnet(IPAddress ip, IPAddress sn, int mask);
int contains(char *str, char *substr);
int lower_contains(char *str, char *str2);

void date_to_str(struct tm *tb, char *dout, int type);
int compare_ip_addresses(char *r1, char *r2);
void speed_to_str(unsigned long spd, char *buf);
void interface_type_to_str(int type, char *buf);

int lock(char *fname);
void unlock(int fd);

#endif

