/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#ifndef NETWORK_H
#define NETWORK_H 1

#include <stdio.h>
#include "visual.h"
#include "list.h"
#include "misc.h"

class Data;
class Network : public Visual
{
	public:
		Network();
		~Network();

		void clear();
		void save(FILE *f);
		void print();
		void load(FILE *f, List *rtr, List *mach, List *sns);
		void savexml(xmlNodePtr xmlnode);
		void loadxml(xmlNodePtr xmlnode, List *rtr, List *mach, List *sns);

		int view;							// little cloud / subnet / machine list
		List interfaces;
		List machines;
		List subnets;
};

#endif

/* Things that are local to client view

	view
	x
	y
	w
	h
	selected
	show
	visited
	find
	fix

*/

