/*****************************************************************************
 Copyright  Newcastle University
 Author      Paul Coates
 *****************************************************************************/
#include "device.h"
#include "iface.h"
#include "mac.h"
#include "route.h"
#include "address.h"

Device::Device()
{
	clear();
}

void Device::clear()
{
	strcpy(name, "");
	strcpy(community, "public");
	type = 'u';	// unknown
	grab_time = 0;
	num_interfaces = 0;
	num_addresses = 0;
	num_macs = 0;
	num_routes = 0;
	interfaces = NULL;
	addresses = NULL;
	macs = NULL;
	routes = NULL;
}

void Device::print()
{
	int i;
	printf("Device %s,%s,", name, community);
	printf(",%c,", type);
	print_time(grab_time);
	printf("\n");
	printf("%d interfaces\n", num_interfaces);
	for (i=0; i<num_interfaces; i++)
		interfaces[i].print();
	printf("%d addresses\n", num_addresses);
	for (i=0; i<num_addresses; i++)
		addresses[i].print();
	printf("%d macs\n", num_macs);
	for (i=0; i<num_macs; i++)
		macs[i].print();
	printf("%d routes\n", num_routes);
	for (i=0; i<num_routes; i++)
		routes[i].print();
}

